  

/*
  DCC Booster using the L6203 H-Bridge  4A c задержкой по отключению 
*/
#define Alarmled 13 // зеленый
#define Redled 5 // красный светодиод - индикация КЗ
#define PowerOnPin 3// pin to turn booster on/off
#define ExtStopPin 9 // команда на рокобустер о КЗ
#define BlueLed 4 // синий - сигнализирует вход внешнего  DСС
#define VAmpIntPin  A1  
#define DccReadPin A2
#define SHORT_reset_pin 10 // кнопка сброса КЗ
#define MAXcur 400 // 2.5 v=512 для 0.5 ом - 500 , для 0.33 - 400
#define AVGcur 300  // для 0.5 ом 400 , для 0.33 - 300 
int CurrentPinReading = 0;
boolean Powerstate = false; //false;
boolean DCCstate = false; //false; true
boolean SHORTstate = false;
boolean SHORT_mode = false; 
float BoosIntCur = 0.0;
unsigned long now =0;
unsigned long currentMillis =0; 
long cAverage = 0;
int avgTimes = 250;
int dcc =300;
int Time = 75;  // задержка 0.1 сек на КЗ
unsigned long SHORT =0;

   int ledState = LOW;
   long previousMillis = 0;        // храним время последнего переключения светодиода
   long interval = 300;
  
void setup() {  
      pinMode(Redled, OUTPUT);//pin 2
      pinMode(BlueLed, OUTPUT);//pin 5
      pinMode( ExtStopPin, OUTPUT);//9
      pinMode(PowerOnPin, OUTPUT );     
      pinMode(Alarmled, OUTPUT );
      pinMode(SHORT_reset_pin, INPUT_PULLUP);      
      digitalWrite(ExtStopPin, HIGH);
      now = millis();
      
if (digitalRead(SHORT_reset_pin) == 0) { SHORT_mode = true ;  interval = 150; }
      
}

void loop() {
   cAverage = 0;
   for (int xx = 0; xx < avgTimes ; xx++) {
    CurrentPinReading = analogRead(VAmpIntPin);   
          if (CurrentPinReading >= MAXcur) {

            digitalWrite(Redled, HIGH);
     delay(Time);
  
  if (analogRead(VAmpIntPin) >= AVGcur)  {  
    Powerstate =false;   
    digitalWrite(PowerOnPin, LOW);   digitalWrite(Redled, HIGH); digitalWrite (BlueLed, LOW);
   if(SHORT_mode == false)  {digitalWrite(ExtStopPin, LOW); } // даем команду о КЗ на  КС
      SHORT =0;
      if(SHORT_mode == true)  { SHORTstate = true ;}
   
  }  
  else {digitalWrite(Redled, LOW);}
  
          }             
    cAverage = cAverage + CurrentPinReading;}
    
    CurrentPinReading = cAverage / avgTimes;
    
   if (CurrentPinReading >= AVGcur) { 
     digitalWrite(Redled, HIGH);
     delay(Time);
  
  if (analogRead(VAmpIntPin) >= AVGcur)  {  
    Powerstate =false;   
    digitalWrite(PowerOnPin, LOW);   digitalWrite(Redled, HIGH); digitalWrite (BlueLed, LOW);
    if(SHORT_mode == false)  {digitalWrite(ExtStopPin, LOW); }  // даем команду о КЗ на  КС
    SHORT =0;
    if(SHORT_mode == true)  { SHORTstate = true ;}
  }  
  else {digitalWrite(Redled, LOW);}
    
                    
    }
   
    if (millis() - now >= 300) {  // проверяем состояние импульсов DCC   
         dcc = analogRead(DccReadPin);
     if ( dcc <100 || dcc > 450) {   DCCstate = false; }
     else {   DCCstate = true; }
        
 
   if(  DCCstate == true &&  Powerstate == false && SHORT > 6 &&  SHORT_mode == false ) {
    digitalWrite(BlueLed, HIGH);
    digitalWrite(PowerOnPin, HIGH);
    digitalWrite(Redled, LOW);
    Powerstate = true;
   }
 

  if(  DCCstate == true &&  Powerstate == false && SHORTstate == false &&  SHORT_mode == true) {
    digitalWrite(BlueLed, HIGH);
    digitalWrite(PowerOnPin, HIGH);
    digitalWrite(Redled, LOW);
    Powerstate = true;
   }  

   
   if(  DCCstate == false &&  Powerstate == true ) {
    Powerstate =false; 
    digitalWrite (BlueLed, LOW);
    digitalWrite(PowerOnPin, LOW);
   }
 now = millis();  
 } 

     currentMillis = millis();   
    if(currentMillis - previousMillis > interval) {  
    previousMillis = currentMillis; 
    if (ledState == LOW)
     { ledState = HIGH; SHORT ++;}
    else
      ledState = LOW;
      digitalWrite(Alarmled, ledState);
  }  
  if (SHORT == 6  && SHORT_mode == false ) {  digitalWrite(ExtStopPin, HIGH);} // снимаем  команду о КЗ на  КС

   if (  digitalRead(SHORT_reset_pin) == 0 ) {  SHORTstate =  false ; } 
  
 } //END LOOP




